/**
 * BroadcastChannel support for AsyncCall.
 * Please make sure your serializer can convert JSON RPC payload into one of the following data types:
 * - Data that can be [structure cloned](http://mdn.io/structure-clone)
 */
export class BroadcastMessageChannel extends BroadcastChannel {
    on(eventListener) {
        const f = (e) => eventListener(e.data);
        this.addEventListener('message', f);
        return () => this.removeEventListener('message', f);
    }
    send(data) {
        super.postMessage(data);
    }
}
//# sourceMappingURL=broadcast.channel.js.map