/**
 * WebSocket support for AsyncCall.
 * Please make sure your serializer can convert JSON RPC payload into one of the following data types:
 *
 * - string
 * - ArrayBuffer
 * - SharedArrayBuffer
 * - Blob
 * - ArrayBufferView
 */
export class WebSocketMessageChannel extends WebSocket {
    on(listener) {
        const f = (e) => listener(e.data);
        this.addEventListener('message', f);
        return () => this.removeEventListener('message', f);
    }
    send(data) {
        if (this.readyState === this.CONNECTING) {
            this.addEventListener('open', () => this.send(data), { once: true });
        }
        else
            super.send(data);
    }
}
//# sourceMappingURL=websocket.client.js.map