export class WorkerChannel {
    /**
     * @param worker Pass the Worker in the main thread.
     */
    constructor(worker = self) {
        Object.defineProperty(this, "worker", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: worker
        });
    }
    on(listener) {
        const f = (ev) => listener(ev.data);
        this.worker.addEventListener('message', f);
        return () => this.worker.removeEventListener('message', f);
    }
    send(data) {
        this.worker.postMessage(data);
    }
}
//# sourceMappingURL=worker.js.map